#include <cxxtest/TestSuite.h>

class GlobalFixture: public CxxTest::GlobalFixture
{
public:
    int setUpCount;
    int tearDownCount;
	int worldSetupCount;
	int worldTeardownCount;

    GlobalFixture()
		: setUpCount(0)
		, tearDownCount(0)
		, worldSetupCount(0)
		, worldTeardownCount(0)
	{}

    bool setUp()
	{
		++setUpCount;
		return true;
	}
    bool tearDown()
	{
		++tearDownCount;
		return true;
	}

    bool setUpWorld()
	{
		++worldSetupCount;
		return true;
	}
    bool tearDownWorld()
	{
		++worldTeardownCount;
		return true;
	}
};

static GlobalFixture globalFixture;

class TestSuiteForGlobalFixture: public CxxTest::TestSuite
{
public:
    void testCountsFirstTime()
    {
        TS_ASSERT_EQUALS(globalFixture.setUpCount, globalFixture.tearDownCount+1);
    }

    void testCountsSecondTime()
    {
		TS_ASSERT_EQUALS(globalFixture.worldSetupCount, 1);
		TS_ASSERT_EQUALS(globalFixture.worldTeardownCount, 0);
    }
};
