//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "ByteSize.hpp"
#include "modassert/assert.hpp"
#include <string>

void ByteSize::SetContent(const std::string &str)
{
	std::istringstream stream(str.c_str());

	float f;
	std::string units;
	stream >> f >> units;

	unsigned int unitSize=0;

	if ( (units=="byte") || (units=="bytes") )
		unitSize = 1;
	else if (units=="kB")
		unitSize = 1000;
	else if (units=="KiB")
		unitSize = 1<<10;
	else if (units=="MB")
		unitSize = 1000000;
	else if (units=="MiB")
		unitSize = 1<<20;
	else if (units=="GB")
		unitSize = 1000000000;
	else if (units=="GiB")
		unitSize = 1<<30;
	else
		throw ByteSizeException("the unit `"+units+"' is not recognized");

	nrBytes = f*(float)unitSize;
}

unsigned int ByteSize::operator()() const
{
	return nrBytes;
}
