//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "uquonitest/Test.hpp"
#include "richbool/richbool.hpp"
#include "uquonitest/MFCExceptionCatcher.hpp"
#include <afx.h>
#include <afxwin.h>

uqtTEST_GROUP(Resource)
{
	uqtADD_TEST_WRAPPER(UquoniTest::GetMFCExceptionCatcher());

	uqtTEST(ThrowException)
	{
		// Uncomment next line to see how an uncaught MFC exception is handled.
		//THROW(new CMemoryException);
	}

	uqtTEST(String1)
	{
		// This test checks whether we can read the resources.

		TCHAR buffer[25];
		int rv = LoadString(GetModuleHandle(NULL), 1, buffer, 25);

		uqtASSERT(rbDIFF(rv, 0));
		uqtASSERT(rbSTRCMP(buffer, ==, "UquoniTest"));
	}

	uqtTEST(ArchiveException)
	{
		// This test checks whether MFC resources are found.
		// See the documentation for how to do this.

		CArchiveException exc(CArchiveException::readOnly, "file.ext");
		char excMsg[255];
		unsigned int helpContext = 0;
		
		uqtASSERT(exc.GetErrorMessage(excMsg, sizeof(excMsg), &helpContext)!=0);
		uqtASSERT(*excMsg!=0);

		// The next line may fail if your resources contain a translated
		// version of this string. The most important thing is that the
		// previous two checks didn't fail.
#if _MSC_VER >= 1500
		uqtASSERT(
			rbSTRCMP(excMsg, ==, "Attempted to write to the reading file.ext.")
		);
#else
		uqtASSERT(
			rbSTRCMP(excMsg, ==, "An attempt was made to write to the reading file.ext.")
		);
#endif
	}
}
