//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "SumOfIntsInFiles.hpp"
#include <fstream>

SumOfIntsInFiles::SumOfIntsInFiles(): m_sum(0), m_nrFiles(0)
{
}

void SumOfIntsInFiles::Process(const std::string &dir)
{
	std::string files = dir+"/files.txt";
	std::ifstream file_with_files(files.c_str());

	while (true)
	{
		std::string nextFile;
		file_with_files >> nextFile;
		if (nextFile.empty())
			break;
		ProcessFile(dir+"/"+nextFile);
	}

	std::string resultFilename = dir+"/results.txt";
	std::ofstream results(resultFilename.c_str());
	results
		<< "Nr of files: " << m_nrFiles << std::endl
		<< "Sum: " << m_sum << std::endl;
}

void SumOfIntsInFiles::ProcessFile(const std::string &filename)
{
	std::ifstream file(filename.c_str());
	while (!file.eof())
	{
		int n;
		file >> n;
		m_sum += n;
	}
	++m_nrFiles;
}

int SumOfIntsInFiles::GetSum() const
{
	return m_sum;
}
