//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "TestEncryption.hpp"
#include "XOREncryption.hpp"

// This is a demonstration of abstract tests.
// Here is the testgroup for one derived class of Encryption,
// namely XOREncryption.

// See also the files TestEncryption.hpp, TestEncryption.cpp
// and TestJuliusCaesarEncryption.cpp.

uqtTEST_GROUP(XOREncryption)
{
	class uqtFixture: public uqtFIXTURE(Encryption)
	{
		// add an object of a derived class of Encryption:
		XOREncryption xorEncryption;

	public:
		uqtFixture(): xorEncryption("g78jt54'")
		{
			// make the pointer encryption in the base class point to
			// our derived object, so it will be used in the tests:
			encryption = &xorEncryption;
		}
	};

	uqtRUN_CONCRETE_TESTS(Encryption);
}
