//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com


#include "uquonitest/Control.hpp"
#include "modassert/handler.hpp"

int main(int argc, const char* argv[])
{
	// Necessary to catch ModAssert assertions in domain code:
	ModAssert::SetResponder(UquoniTest::GetModAssertResponder());

	// Necessary to check that all project files
	// of different compilers contain the same tests:
	UquoniTest::CheckFilePresence("filepresence.xml");

	// Add test listener that prints test progress:
	UquoniTest::AddTestResultPrinter();

	// Necessary to use trial version:
	UquoniTest::SetIsRunningWithKey(false);

	// Run the tests:
	int rv = UquoniTest::ConsoleTestRunner::RunTests(argc, argv);

	return rv;
}
