//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

// UquoniTestExampleMFC.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "UquoniTestExampleMFC.hpp"

// include file with several UquoniTest functions
// (also causes automatic linking to the correct importy library of the UquoniTest DLL):
#include "uquonitest/Control.hpp"

// automatically link to the correct import library of the MFCExceptionCatcher DLL:
#include "uquonitest/MFCExceptionCatcherAutoLink.hpp"

#include "modassert/handler.hpp"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CWinApp theApp;

using namespace std;

int _tmain(int argc, TCHAR* argv[], TCHAR* envp[])
{
	int nRetCode = 0;

	if (!AfxWinInit(::GetModuleHandle(NULL), NULL, ::GetCommandLine(), 0))
	{
		cerr << _T("Fatal Error: MFC initialization failed") << endl;
		return 1;
	}
	else
	{
		// Necessary to catch ModAssert assertions in domain code:
		ModAssert::SetResponder(UquoniTest::GetModAssertResponder());

		// Necessary to check that all project files
		// of different compilers contain the same tests:
		UquoniTest::CheckFilePresence("filepresence-MFC.xml");

		// Add test listener that prints test progress:
		UquoniTest::AddTestResultPrinter();

		// Necessary to use trial version:
		UquoniTest::SetIsRunningWithKey(false);

		// Run the tests:
		int rv = UquoniTest::ConsoleTestRunner::RunTests(argc, argv);

		return rv;
	}
}
