//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "XOREncryption.hpp"

std::string XOREncryption::Encrypt(const std::string &str)
{
	std::string encrypted(str.size(), ' ');
	size_t keySize = key.size();

	for (size_t i=0; i<str.size(); ++i)
	{
		encrypted[i] = str[i]^key[i%keySize];
	}
	return encrypted;
}

std::string XOREncryption::Decrypt(const std::string &str)
{
	// this encryption is symmetric
	return Encrypt(str);
}




