//  Copyright (C) 2006-2009 Q-Mentum.
//  See the file license.txt for limitations on usage of this code.

//  For more information about Q-Mentum, visit http://www.q-mentum.com

#include "DNA.hpp"
#include "modassert/assert.hpp"
#include <algorithm>

void Complement(std::string &sequence)
{
	for (std::string::iterator it=sequence.begin(); it!=sequence.end(); ++it)
		switch (*it)
		{
		case 'a':
			*it = 't';
			break;
		case 'c':
			*it = 'g';
			break;
		case 'g':
			*it = 'c';
			break;
		case 't':
			*it = 'a';
			break;
		default:
			MOD_FAIL_P(*it << it-sequence.begin());
			break;
		}
}

void ComplementReverse(std::string &sequence)
{
	Complement(sequence);
	std::reverse(sequence.begin(), sequence.end());
}




